jQuery( document ).ready( function( $ ) {

	function onPaymentMethodReceived( paymentData ) {

		$( 'body' ).block( {
			message: null,
			overlayCSS: {
				background: '#fff',
				opacity: 0.6
			}
		} );

		$.ajax( {
			type: 'POST',
			url: paypalBraintreeData.checkoutWithPayPal.detailsPostbackURL,
			data: paymentData,
			dataType: "json"
		} ).done( function( responseData ) {
			if ( 'undefined' !== typeof responseData.success && responseData.success ) {
				if ( 'undefined' !== typeof responseData.redirectTo ) {
					window.location = responseData.redirectTo;
				}
			}
		} );
	}

	if ( 'undefined' === typeof braintree ) {
		return;
	}

	if ( 'undefined' === typeof paypalBraintreeData || 'undefined' === typeof paypalBraintreeData.token || 'undefined' === typeof paypalBraintreeData.checkoutWithPayPal ) {
		return;
	}

	if ( ! paypalBraintreeData.checkoutWithPayPal ) {
		return;
	}

	if ( 0 === $( '#paypal-braintree-button-container' ).length ) {
		return;
	}

	var setupArgs = {
		paypal : {
			container: "paypal-braintree-button-container",
			singleUse: true, // cart checkout must always be single use
			amount: paypalBraintreeData.checkoutWithPayPal.amount,
			currency: paypalBraintreeData.checkoutWithPayPal.currency
		},
		onPaymentMethodReceived: onPaymentMethodReceived
	};

	braintree.setup( paypalBraintreeData.token, "custom", setupArgs );

} );